//Cone for Brother wool winder
//Owen Mace 27July2020

TopDiameter = 45;
BottomDiameter = 55;
ConeHeight = 95;
SkirtDiameter = 59;
SkirtHeight = 15;
WallThickness = 1.5;
Tolerance = 0.2;

$fn = 50;

rotate([ 180, 0, 0])
{
  difference()
  {
    union()
    {
      //Cone
      cylinder( h = ConeHeight, d1 = BottomDiameter, d2 = TopDiameter, center = true);
      //Skirt
      translate([ 0, 0, -ConeHeight / 2 - SkirtHeight])
        cylinder( h = SkirtHeight, d = SkirtDiameter);
    }
    //Remove inside of cone
    cylinder( h = ConeHeight     - WallThickness * 2,
             d1 = BottomDiameter - WallThickness * 2,
             d2 = TopDiameter    - WallThickness * 2, center = true);
    //Remove inside of skirt
    translate([ 0, 0, -ConeHeight / 2 - SkirtHeight - .95])
      cylinder( h = SkirtHeight   + WallThickness * 2 + .1,
                d = BottomDiameter - WallThickness * 2);
    //Remove slots
    for (i = [ 0: 180: 200])
    {
      rotate([ 0, 0, i])
      {
        translate([ 0, 0, -ConeHeight / 2 - SkirtHeight + 4.8])
          rotate_extrude( angle = 70, convexity = 10)
          translate([ SkirtDiameter / 2 - 0.5, 0, 0])
            square([2.5, 3.6], center = true);
        translate([ 0, 0, -ConeHeight / 2 - SkirtHeight + 1.79])
          rotate_extrude( angle = 35, convexity = 10)
          translate([ SkirtDiameter / 2 - 0.5, 0, 0])
            square([2.5, 3.6], center = true);
      }
    }
    //Remove slot for yarn
    translate([ 0, -TopDiameter / 2 - Tolerance - 5, ConeHeight / 2 + 0.01])
    rotate([ -90, 0, 0])
      linear_extrude( height = TopDiameter+ 10)
        polygon( [[  -1.5,  0], [ 1.5,  0], [  0, 15]]);
    //Remove hole in the top
    cylinder( h = ConeHeight, d = 10);
  }
}

